
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

#if !defined(_MAC) && !defined(_WINDOWS) && !defined(_NTWIN) && !defined(_NEXT)
#  include <unistd.h>
#else
#  if defined(_WINDOWS) || defined(_NTWIN)
#    include <io.h>
#    define  ISATTY        _isatty
#    define  LSEEK         _lseek
#    define  CLOSE         _close
#    define  READ          _read
#    define  WRITE         _write
#    define  OPEN          _open
#  endif                   // NT or WIN
#endif                     // not NT WIN MAC or NEXT

#include "ctpdefs.h"

const int CTP_filebuf_size = 0x1000;


class CTPfilebuf : public streambuf
{

  public:
    enum { openprot = 644 };
    enum lseek_consts { begin=SEEK_SET, current=SEEK_CUR, end=SEEK_END };


  // Constructors
    CTPfilebuf();
    CTPfilebuf(int file_descriptor, int io_mode = ios::out);
    CTPfilebuf(int file_descriptor, char *memory, int length, int io_mode = ios::out);

    virtual ~CTPfilebuf();

  // Attach a fileto an existing filebuf
    CTPfilebuf *attach(int file_descriptor, int io_mode = ios::out);

  // Do allocation
    int doallocate();

  // Open a file and attach itto an existing filebuf
    CTPfilebuf *open(const char *name, int io_mode, int protection = openprot);

  // Close the file asscoicated with the filebuf
    CTPfilebuf *close();

  // Information functions
    const int fd() { return file; }
    const int is_open() { return file == EOF; }

  // Seek functions
    virtual streampos seekpos(streampos pos, int which_pointers);
    virtual streampos seekoff(streamoff offset, lseek_consts seek_dir, int which_pointers);

  // Offer a buffer area for use
    virtual streambuf *setbuf(char *memory, int length);

  // Synchronize the file with the filebuf
    virtual int sync();

  protected:
    virtual int underflow();
    virtual int overflow(int = EOF);

    virtual int pbackfail(int);

  private:

    int file;          // File descriptor for the associated file
    short mode;        // IO mode
    short reserve;     // remaining putback reserve
    char unbuf[2];     // two character buffer for unbuffered operation
    char do_not_seek;  // Set if the file device does not support seeks
    char own_file_descriptor;   // Set if the file descriptr is from open, and
                                // the file should be closed by the destructor

  // Private member functions
    int syncin();
    int syncout();
    int flushbuf();
    int fillbuf();

};
