#ifndef CTPOUTPUT_H
#define CTPOUTPUT_H

class CTPLog;

//
// OutputFunction will be passed into the constructor of any new
//   log objects.  It is resonsible for opening and writing data
//   to files, windows or anywhere the user desires.  A couple of
//   default OutputFunctions are provided.  But the user can change
//   to his/her own function at anytime.  (Provided they follow the
//   OutputFunction statndards
//
typedef short (*OutputFunction)(CTPLog &log);
typedef short (*TruncateFunction)(CTPLog &log);

extern short OutputLogFile(CTPLog &log);
extern short OutputDebugLog(CTPLog &log);
extern short OutputErrorLog(CTPLog &log);
extern short OutputLog(CTPLog &log);

#if !defined(MAC) && !defined(WIN3_X) && !defined(_NTWIN) && !defined(NEXT) 
extern short OutputSyslog(CTPLog &log);
#endif
#if defined(_NTWIN) || defined(WIN3_X)
extern short OutputDebugWin(CTPLog& log);
#endif

extern short TruncateLog(CTPLog &log);
	                          
#endif






