#ifndef MSGTYPE_H
#define MSGTYPE_H


#include "ctpdefs.h"

//
// TokenMask Class
//		This class is designed to generate a mask that is
//		maskSize*sizeof(long) bytes long.
//
//class EXPORT TokenMask		// Mask for 64 masks
//{
//  public:
// 	TokenMask(const short maskSize = 1); // Constructor: How large is the Mask
//	~TokenMask();						// Destructor
//	short numBitMasks();				// Number of Bits in the Mask
//
// private:
//	long * 		maskPtr;				// Pointer to the first byte of the mask
//	short		maskSize;				// Size of the mask in bytes
//};
//
//
// MsgToken Class
//    This class is designed to send information about a message
//    to the log class.
//


// As it stands right now this class only handles 32 types
// This can be easily changed later by changing the TokenMask class

typedef long TokenMask;



const int NEXT_INDEX     =    -1;       // This will use the next availible index wiht a new MsgToken
const int TEMP_INDEX     =    31;       // This is a working index, to save using up good index space


class EXPORT MsgToken
{
  public:
  	MsgToken(int msgIndex = NEXT_INDEX);
 //	MsgToken(CTPString msgName, int msgIndex = NEXT_INDEX);
	MsgToken(CTPString msgName, int msgIndex);
	~MsgToken();

	void unsetMsgTokenIDMask();
	CTPString& setMsgTokenName(const CTPString msgTokenName);
	const CTPString& getMsgTokenName() const;
	TokenMask& setMsgTokenIDMask(const int msgTokenNumb, const CTPBoolean setFlag=True);
	const TokenMask& getMsgTokenIDMask() const;

	MsgToken operator | (const MsgToken&);

 private:
	int nextAvailIndex();				// Get the next availible index
 	static TokenMask	msgTokenIDMaskList;	// List of all the masks
	CTPString		msgTokenName;		// Name of the message type
	TokenMask		msgTokenIDMask;		// ID Mask for the message token (0-31)
};


#endif
