/*
 * sampleClient.C:
 *    This simple program looks up our sample binding and calls "CallMe"
 * once. It takes one argument -- the name with which the server registered
 * itself with CDS.
 *
 * sampleClient.C,v 1.4 1993/11/30 02:00:00 gjb Exp
 */
#include <objdce/defs.h>
#include <objdce/bindingDefs.h>
#include <objdce/rpcmap.h>
#include <objdce/statics.H>     /* Necessary for SunOS bug workaround */
#include <afx.h>
#include <iostream.h>
#include <objdce/binding.H>
#include <objdce/uuid.H>
#include <objdce/mutex.H>
#include <objdce/thread.H>
#include <test.h>
#include <ctplog.h>
#include <ctpfbuf.h>

extern "C"
{
#include <rpc.h>
}


class MyThread: public ThreadObject
{
public:
	MyThread() {}
	virtual void* Run();
};


void* MyThread::Run()
{
	int success = 0;
	int failure = -1;
	int *flag;
        error_status_t RpcStatus;	
	pthread_addr_t status;
        Binding *svrBinding; 
	pthread_addr_t id = pthread_self();
	int *pid = (int *)id;

	for (int i=0; i<500; ++i)
		LOGERR << "Thread executing =   " << *pid << endl;	

#if 0
	int *tid = (int *) id;

	printf("Thread # %d executing\n", *tid);
  
  	svrBinding = new Binding("/.:/ta/rmall/hwu", RPCClient(Test, 0, 0),
			   (LoginContext*)0);

	  if (svrBinding->IsValid()) 
		LOGDBG << "Binding lookup succeeded\n";
  	  else { 
		LOGERR << "Binding lookup failed \n";
		delete svrBinding;
		status = &failure; 
		pthread_exit(status);
    	   }

         RpcStatus = CallMe(
	         *svrBinding,
	         3);
         printf("CallMe returned with status = %d\n", RpcStatus);


	 if (RpcStatus != RPC_S_OK) {
		 fprintf(stderr,
			"Error: cannot execute CallMe status error: %d\n",
				status);
		 status = &failure;
		 pthread_exit(status);
    	 }
    	else 
	   printf("rpc CallMe succeded!!\n");

    
  delete svrBinding;	

#endif
  status = &success;
  pthread_exit((pthread_addr_t) status);
  return status;
}


void
main(int argc, char** argv)
{
  int *ret, flag;
  pthread_mutex_t mutex;
  pthread_attr_t attr;  
  void* returnValue, *arg;
  CTPfilebuf fb;


  fb.open("test.out", ios::out);
  ostream outfile(&fb);
  if (outfile.bad())
  {
  	cerr << "Error opening output" << endl;
    	return;
  }
  LOGDBG.setOutputStream(&outfile);
  LOGERR.setOutputStream(&outfile);

  LOGDBG.setHeader( CTPLog::FILENAME | CTPLog::LINENUMBER );
  LOGERR.setHeader( CTPLog::FILENAME | CTPLog::LINENUMBER );

  LOGDBG.setLogSeverity(CTPLog::LOG_INFORMATIONAL);
  LOGERR.setLogSeverity(CTPLog::LOG_INFORMATIONAL);
  LOGERR.setMsgSeverity(CTPLog::MSG_FATAL);
  

  if ((argc < 2) || (argc > 3))
  {
	printf("test nameSpace <\"shutdown\">\n");
	return;
  }

 if ((argc == 3)&& (!strcmp("shutdown", argv[2]))) 
	flag = 1;
 else
	flag = 0;
 arg = &flag;
 

  MyThread* anObject = new MyThread();
  AsyncThread* a1Thread = new AsyncThread(*anObject);
#if 1 
  AsyncThread* a2Thread = new AsyncThread(*anObject);
#endif

  returnValue = a1Thread->Wait();
  ret = (int *)returnValue;
  printf("Return value from first spawned thread %d\n", *ret);

#if 1 
  returnValue = a2Thread->Wait();
  ret = (int *)returnValue;
  printf("Return value from second spawned thread %d\n", *ret);
#endif
  delete a1Thread;
#if 1 
  delete a2Thread;
#endif
  delete anObject;
 
  LOGDEBUGLEVEL(CTPLog::MSG_WARNING) << "Main thread returned " << (int)*ret << "\n";
 
 return; 
}
